! -*- F90 -*-
      subroutine xmatel(nexl,nexr)
        implicit none
        integer :: nexl,nexr,i,j,norbi,isign,jsign,j1,ih,ihole
        integer :: ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2,iequal,ipart
        integer :: i1,i2,j2,ndiff,lspin,nholes,lsub,nequal,idum
        integer :: jj,lfound,irp1,irp2,irpa,irpb,nleft,nright,indx
        integer :: ilhb,ilpa,ilpb,irha,irhb,ilha
        logical*1 :: lsame

        do i=1,2*max(nexl,nexr)
         ileft2(i)=0
         iright2(i)=0
        end do
        
!!$        write(6,*) ' left string :  ',(ileft(i),i=1,2*nexl)
!!$        write(6,*) ' right string : ',(iright(i),i=1,2*nexr)
!
! how many holes in the lhs ?
        ilha=0
        ilhb=0
        ilpa=0
        ilpb=0
        do i=1,2*nexl
         if (ileft(i).lt.0) then
          if (abs(ileft(i)).le.nocc) then
           ilhb=ilhb+1
           itypel(i)=1
           ispinl(i)=1
          else 
           ilpb=ilpb+1
           itypel(i)=2
           ispinl(i)=1
          end if
         else if (ileft(i).gt.0) then
          if (ileft(i).le.nocc) then
           ilha=ilha+1 
           itypel(i)=1
           ispinl(i)=2
          else
           ilpa=ilpa+1 
           itypel(i)=2
           ispinl(i)=2
          end if
         end if
        end do
        
        irha=0
        irhb=0
        irpa=0
        irpb=0
        do i=1,2*nexr
         if (iright(i).lt.0) then
          if (abs(iright(i)).le.nocc) then
           irhb=irhb+1
           ityper(i)=1
           ispinr(i)=1
          else
           irpb=irpb+1
         ityper(i)=2
         ispinr(i)=1
        end if 
       else if (iright(i).gt.0) then
        if (iright(i).le.nocc) then
         irha=irha+1 
         ityper(i)=1
         ispinr(i)=2
        else
         irpa=irpa+1 
         ityper(i)=2
         ispinr(i)=2
        end if 
       end if 
      end do 
      nleft=ilha+ilhb+ilpa+ilpb
      nright=irha+irhb+irpa+irpb
      
!!$      write(6,*) ' left  determinant : holes alpha, beta ',ilha,ilhb
!!$      write(6,*) ' left  determinant : part. alpha, beta ',ilpa,ilpb
!!$      write(6,*) ' right determinant : holes alpha, beta ',irha,irhb
!!$      write(6,*) ' right determinant : part. alpha, beta ',irpa,irpb

      if (ilha.ne.ilpa) stop ' error in holes/particles alpha lhs'
      if (ilhb.ne.ilpb) stop ' error in holes/particles beta  lhs'
      if (irha.ne.irpa) stop ' error in holes/particles alpha rhs'
      if (irhb.ne.irpb) stop ' error in holes/particles beta  rhs'

! transform the strings to occupations
      indx=0
      do i=1,2*nexl
       if (ileft(i).ne.0.and.abs(ileft(i)).le.nocc) then
        indx=indx+1
        ileft2(indx)=ileft(i)
       end if
      end do
      if (indx.ne.nexl) stop ' left determinant incorrectly specified '

      do i=1,2*nexr
       if (iright(i).ne.0.and.abs(iright(i)).le.nocc) then
        indx=indx+1
        ileft2(indx)=iright(i)
       end if
      end do
      if (indx.ne.nexl+nexr) stop ' right determinant incorrectly specified '

!!$      write(6,*) ' ileft2 ',(ileft2(jj),jj=1,nexl+nexr)
!
! eliminate same holes
!
      do i=1,nexl+nexr
       do j=i+1,nexl+nexr
        if (ileft2(i).eq.ileft2(j).and.ileft2(i).ne.0) then
         ileft2(j)=0 
        end if
       end do
      end do

      isign=1
!
! we may have nexl+nexr different holes
! 1 2 3 4
!
! they may be reduced to 3 or 2, and during this action the rhs holes
! may have changed their order
!
      norbi=nexl+nexr
      do i=1,nexl+nexr
       if (ileft2(i).eq.0) then
        lfound=0
        do j=i+1,nexl+nexr
         if (lfound.eq.0) then
          if (ileft2(j).ne.0) then
           ileft2(i)=ileft2(j)
           ileft2(j)=0
           lfound=1
          end if
         end if
        end do
       end if
      end do

      norbi=0
      do i=1,nexl+nexr
       if (ileft2(i).ne.0) norbi=norbi+1
      end do

! check order of the rhs holes
      if (irha.ge.2.or.irhb.ge.2) then
       do i=1,norbi
        if (ileft2(i).eq.iright(1)) irp1=i
        if (ileft2(i).eq.iright(2)) irp2=i
       end do
       if (irp1.gt.irp2) isign=-isign
      end if

!!$      write(6,9902) norbi,(ileft2(j),j=1,norbi)
 9902 format('   norbi = ',i4,' string ',20i4)
! save the string of the holes
      do i=1,norbi
       iholes(i)=ileft2(i)
      end do
      nholes=norbi

      do i=1,norbi
       iright2(i)=ileft2(i)
      end do

! now we have to place the particles

      do i=1,norbi
! if this hole appears in the left string, we look for an adequate
! particle 
       lfound=0
       do j=1,2*nexl
        if (ileft2(i).eq.ileft(j)) then
         lfound=1
         lspin=ispinl(j)
        end if
       end do
! and replace the hole
       if (lfound.eq.1) then
        lsub=0
        do j=1,2*nexl
         if (lsub.eq.0) then
! look for a particle with the same spin
          if ((lspin.eq.ispinl(j)).and.(itypel(j).eq.2)) then
           ileft2(i)=ileft(j)
           itypel(j)=0
           lsub=1
          end if
         end if
        end do
       end if
      end do
      
      do i=1,norbi
! if this hole appears in the right string, we look for an adequate
! particle 
       lfound=0
       do j=1,2*nexr
        if (iright2(i).eq.iright(j)) then
         lfound=1
         lspin=ispinr(j)
        end if
       end do
! and replace the hole
       if (lfound.eq.1) then
        lsub=0
        do j=1,2*nexr
         if (lsub.eq.0) then
! look for a particle with the same spin
          if ((lspin.eq.ispinr(j)).and.(ityper(j).eq.2)) then
           iright2(i)=iright(j)
           ityper(j)=0
           lsub=1
          end if
         end if
        end do
       end if
      end do

!!$      write(6,9903) 'left ',(ileft2(j),j=1,norbi)
!!$      write(6,9903) 'right',(iright2(j),j=1,norbi)
!!$      write(6,9804) 'holes ',(iholes(j),j=1,norbi)
 9903 format('   ',a5,' determinant as occupation : ',10i4) 
 9804 format('   ',a5,' in the determinants       : ',10i4)

!
! now we have to determine how many of the indices are equal
!
      nequal=0
      do i=1,norbi
       lfound=0
       do j=1,norbi
        if (ileft2(i).eq.iright2(j).and.lfound.eq.0) then
         nequal=nequal+1
         lfound=1
         if (i.ne.j) then
! exchange i and j in the right string
          isign=-isign
          idum=iright2(j)
          iright2(j)=iright2(i)
          iright2(i)=idum          
         end if
        end if
       end do
      end do
!
! get the different particles to the left-hand side
      do i=1,norbi
       lfound=0
       do j=i,norbi
! are these already different ?
        if (ileft2(j).ne.iright2(j).and.lfound.eq.0) then
         idum=ileft2(i)
         ileft2(i)=ileft2(j)
         ileft2(j)=idum
         idum=iright2(i)
         iright2(i)=iright2(j)
         iright2(j)=idum
         lfound=1 
        end if
       end do
      end do

!!$      write(6,*) '-left ',(ileft2(j),j=1,norbi)
!!$      write(6,*) '-right',(iright2(j),j=1,norbi)
!!$ 
!!$      write(6,*) 'left ',(ileft2(j),j=1,norbi)
!!$      write(6,*) 'right',(iright2(j),j=1,norbi)
      
      ndiff=norbi-nequal

!!$      write(6,*) ' implied orbitals : ',norbi
!!$      write(6,*) ' equal indices    : ',nequal
!!$      write(6,*) ' different indices: ',ndiff
!!$      write(6,*) 
!!$      write(6,*) ' sign of the permutation: ',isign
!!$      
!!$      write(6,9903) 'left ',(ileft2(j),j=1,ndiff)
!!$      write(6,9903) 'right',(iright2(j),j=1,ndiff)

      if (ndiff.le.2) then
       
       do i=1,norbi
        if (ileft2(i).lt.0) then
         ispinl(i)=1
        else
         ispinl(i)=2
        end if
        if (iright2(i).lt.0) then
         ispinr(i)=1
        else
         ispinr(i)=2
        end if
       end do
!
       if (ndiff.eq.0) then
        write(6,*) ' ndiff = 0 : diagonal element '
        write(6,9924) csign(isign)
9924    format('  calculating matrix element : ',a1,'e_hf ')
        do i=1,norbi
         i1=abs(iholes(i))
         j1=abs(ileft2(i))
         write(6,9921) csign(-isign),i1,i1,csign(isign),j1,j1
9921     format(' diagonal element : ',a1,'f (',i3,',',i3,' ) ',a1 &
              ,' f (',i3,',',i3,' )')
        end do

!
! hole-hole, hole-particle and particle-particle interactions
! hole-hole and part-part enter with +
! hole-part enter with -
! same-spin combinations are j-k
! different-spin combinations are j only
!
        do i=1,norbi
         do j=1,norbi

! hole-part and part-hole

          i1=abs(iholes(i))
          j1=abs(ileft2(j))
          
          jsign=1
          if (i1.le.nocc.and.j1.gt.nocc) jsign=-1 
          if (i1.gt.nocc.and.j1.le.nocc) jsign=-1
          if (ispinl(i).eq.ispinl(j)) then
           write(6,9922) csign(isign*jsign), i1,i1,j1,j1, &
                csign(-isign*jsign),i1,j1,i1,j1
          else
           write(6,9923) csign(isign*jsign),i1,i1,j1,j1
          end if 

         end do
        end do

        do i=1,norbi-1
         do j=i+1,norbi
! hole-hole and part-part
          i1=abs(iholes(i))
          j1=abs(iholes(j))
          
          jsign=1
          if (i1.le.nocc.and.j1.gt.nocc) jsign=-1 
          if (i1.gt.nocc.and.j1.le.nocc) jsign=-1
          if (ispinl(i).eq.ispinl(j)) then
           write(6,9922) csign(isign*jsign), i1,i1,j1,j1, &
                csign(-isign*jsign),i1,j1,i1,j1
          else
           write(6,9923) csign(isign*jsign),i1,i1,j1,j1
          end if
          
          
          i1=abs(ileft2(i))
          j1=abs(ileft2(j))
          
          jsign=1
          if (i1.le.nocc.and.j1.gt.nocc) jsign=-1 
          if (i1.gt.nocc.and.j1.le.nocc) jsign=-1
          if (ispinl(i).eq.ispinl(j)) then
           write(6,9922) csign(isign*jsign), i1,i1,j1,j1, &
                csign(-isign*jsign),i1,j1,i1,j1
          else
           write(6,9923) csign(isign*jsign),i1,i1,j1,j1
          end if 

         end do
        end do
9922    format(' diagonal element : ',a1,' (',2i4,'|',2i4,' ) ', &
             a1,' (',2i4,'|',2i4,' ) ')
9923    format(' diagonal element : ',a1,' (',2i4,'|',2i4,' )')
       else if (ndiff.eq.1) then
        i=min(abs(ileft2(1)),abs(iright2(1)))
        j=max(abs(ileft2(1)),abs(iright2(1)))
        write(6,9912) ileft2(1),iright2(1),csign(isign),i,j 
! subtract all hole interactions
        do ih=1,nholes
         ihole=iholes(ih)
!        write(6,*) ' ihole = ',ihole,ileft2(1)
         if (sign(1,ihole).eq.sign(1,ileft2(1))) then
          ihole=abs(ihole)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ihole
          ll1=ihole
          ii2=abs(ileft2(1))
          jj2=ihole
          kk2=abs(iright2(1))
          ll2=ihole
          call ocan(ii1,jj1,kk1,ll1)
          call ocan(ii2,jj2,kk2,ll2)
          if (.not.lsame(ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2)) then
           write(6,9913) ileft2(1),iright2(1), &
              csign(-isign),ii1,jj1,kk1,ll1,csign(isign),ii2,jj2,kk2,ll2
          end if
         else
          ihole=abs(ihole)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ihole
          ll1=ihole
          call ocan(ii1,jj1,kk1,ll1)
          write(6,9914) ileft2(1),iright2(1),csign(-isign),ii1,jj1,kk1,ll1
         end if 
        end do  
! add all particle interactions
        do iequal=1,nequal
         ipart=ileft2(1+iequal)
!        write(6,*) ' ipart = ',ipart
         if (sign(1,ipart).eq.sign(1,ileft2(1))) then
          ipart=abs(ipart)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ipart
          ll1=ipart
          ii2=abs(ileft2(1))
          jj2=ipart
          kk2=abs(iright2(1))
          ll2=ipart
          call ocan(ii1,jj1,kk1,ll1)
          call ocan(ii2,jj2,kk2,ll2)
          if (.not.lsame(ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2)) then
           write(6,9913) ileft2(1),iright2(1),csign(isign),ii1,jj1, &
               kk1,ll1,csign(-isign),ii2,jj2,kk2 ,ll2
          end if
         else
          ipart=abs(ipart)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ipart
          ll1=ipart
          call ocan(ii1,jj1,kk1,ll1)
          write(6,9914) ileft2(1),iright2(1),csign(isign),ii1,jj1,kk1,ll1
         end if
        end do
! we have the interaction with the holes 
       else if (ndiff.eq.2) then
        i1=ileft2(1)
        i2=ileft2(2)
        j1=iright2(1)
        j2=iright2(2)
        do i=1,2
         ileft2(i)=abs(ileft2(i))
         iright2(i)=abs(iright2(i))
        end do
! same spins
        if (ispinl(1).eq.ispinl(2)) then
         
         ii1=ileft2(1)
         jj1=iright2(1)
         kk1=ileft2(2)
         ll1=iright2(2)
         
         call ocan(ii1,jj1,kk1,ll1)
         
         ii2=ileft2(1)
         jj2=iright2(2)
         kk2=ileft2(2)
         ll2=iright2(1)
         call ocan(ii2,jj2,kk2,ll2)
         if (.not.lsame(ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2)) then
          write(6,9915) i1,i2,j1,j2,csign(isign),ii1,jj1,kk1,ll1, &
              csign(-isign),ii2,jj2,kk2,ll2  
         end if
        else
         ii1=ileft2(1)
         jj1=iright2(1)
         kk1=ileft2(2)
         ll1=iright2(2)
         call ocan(ii1,jj1,kk1,ll1)
         write(6,9916)  i1,i2,j1,j2,csign(isign),ii1,jj1,kk1,ll1
        end if
       end if
      else
       write(6,9917)
      end if
      
9904  format(' calculating diagonal element <',4i4,'||', &
           4i4,'> ')
9912  format(' calculating matrix element <',i4,'||',i4 &
           ,'> : interaction ',a1,'F(',i3,',',i3,')',f20.12)
9913  format(' calculating matrix element <',i4,'||',i4 &
           ,'> : interaction ',a1,'(',2i4,'|',2i4,') ',a1,' (',2i4,'|' &
           ,2i4,') ',f20.12) 
9914  format(' calculating matrix element <',i4,'||',i4 &
           ,'> : interaction ',a1,'(',2i4,'|',2i4,') ',f20.12) 
9915  format(' calculating matrix element <',2i4,'||',2i4 &
           ,'> : interaction ',a1,'(',2i4,'|',2i4,') ',a1,' (',2i4,'|' &
           ,2i4,') ',f20.12) 
9916  format(' calculating matrix element <',2i4,'||',2i4 &
           ,'> : interaction ',a1,'(',2i4,'|',2i4,') ',f20.12) 
9917  format(' calculating matrix element : no interaction ') 

    end subroutine xmatel
    
    subroutine ocan(i,j,k,l)
      implicit none
      integer :: i,j,k,l
      integer :: i1,j1,k1,l1,idum
      
      i1=i
      j1=j
      k1=k
      l1=l
      
      if (i1.gt.j1) then
       idum=i1
       i1=j1
       j1=idum
      end if
      if (k1.gt.l1) then
       idum=k1
       k1=l1
       l1=idum
      end if
      
      if (i1.gt.k1) then
       idum=i1
       i1=k1
       k1=idum
       idum=j1
       j1=l1
       l1=idum
      else if (i1.eq.k1) then
       if (j1.gt.l1) then
        idum=j1
        j1=l1
        l1=idum
       end if
      end if
      
      i=i1
      j=j1
      k=k1
      l=l1
      
    end subroutine ocan

