! -*- F90 -*-
      program slater_rules
        implicit none

        WRITE(6,*)
        WRITE(6,*) ' ----------------------------------------------'
        WRITE(6,*)
        WRITE(6,*) '  Slater rules for calculating matrix elements '
        WRITE(6,*) ' of the Hamiltonian between excited determinants '
        WRITE(6,*) '          of a closed-shell reference '
        WRITE(6,*)
        WRITE(6,*) '       implementation using IRPF90 10/2009 '
        WRITE(6,*) '        (Peter Reinhardt, Univ Paris VI) '
        WRITE(6,*)
        WRITE(6,*) ' ----------------------------------------------'
        WRITE(6,*)
        call driver

      end program slater_rules

      subroutine driver
        integer :: kk,i,nexl,nexr

        write(6,*) ' NOCC   = ',nocc
        write(6,*) ' NEXMAX = ',nexmx
        write(6,*) 
        WRITE(6,*) ' ----------------------------------------------'
        WRITE(6,*)

100     continue
        write(6,9901) 
9901    format(' left determinant (excitation ' &
             ,'degree, hole ind., part ind., -1 stops the program)' )
        read(5,*,iostat=kk) nexl,(ileft(i),i=1,2*nexl)
        if (kk.ne.0) go to 200
        if (nexl.eq.-1) then
         write(6,*)
         write(6,*) ' normal end of ',pname
         write(6,*)
         stop
        end if
        if (nexl.gt.nexmx) then
         write(6,*) ' excitation degree larger than anticipated '
         write(6,*) ' you gave nexmx = ',nexmx
        end if
        
        write(6,9902) 
9902    format(' right determinant (excitation ' &
             ,'degree, hole indices, part indices)' )

        read(5,*) nexr,(iright(i),i=1,2*nexr)
        if (nexr.gt.nexmx) then
         write(6,*) ' excitation degree larger than anticipated '
         write(6,*) ' you gave nexmx = ',nexmx
        end if
        call xmatel(nexl,nexr)
        write(6,*) 
        write(6,*)  ' - - - - - - - - - - - - - - - - - -'
        write(6,*) 
        write(6,*) 
        go to 100
200     continue
        
      end subroutine driver
